package jp.ac.aitech.k16106kk.Player15;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Deque;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;
import java.util.Set;

import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.Operator;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Status;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Vote;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ac.aitech.k16106kk.metaStrategy.winRate;

/** すべての役職のベースとなるクラス */
public class Tomato15BasePlayer implements Player {

	/** このエージェント */
	protected Agent me;
	/** 役職 */
	Role myRole;
	/** 日付 */
	protected int day;
	/** talk()できるか時間帯か */
	protected boolean canTalk;
	/** whisper()できるか時間帯か */
	protected boolean canWhisper;
	/** 最新のゲーム情報 */
	protected GameInfo currentGameInfo;
	protected GameSetting gameSetting;
	/** 自分以外の生存エージェント */
	protected List<Agent> aliveOthers;
	/** 追放されたエージェント */
	protected List<Agent> executedAgents = new ArrayList<>();
	/** 殺されたエージェント */
	protected List<Agent> killedAgents = new ArrayList<>();
	/** 発言された占い結果報告のリスト */
	protected List<Judge> divinationList = new ArrayList<>();
	/** 黒出しされたエージェント */
	protected List<Agent> blackDivineList = new ArrayList<>();
	/** 白だしされたエージェント */
	protected List<Agent> whiteDivineList = new ArrayList<>();
	/** 発言された霊媒結果報告のリスト */
	protected List<Judge> identList = new ArrayList<>();
	/** 発言用待ち行列 */
	protected Deque<Content> talkQueue = new LinkedList<>();
	/** 囁き用待ち行列 */
	protected Deque<Content> whisperQueue = new LinkedList<>();
	/** 投票先候補 */
	protected Agent voteCandidate;
	/** 宣言済み投票先候補 */
	protected Agent declaredVoteCandidate;
	/** 襲撃投票先候補 */
	protected Agent attackVoteCandidate;
	/** 宣言済み襲撃投票先候補 */
	protected Agent declaredAttackVoteCandidate;
	/** カミングアウト状況 */
	protected Map<Agent, Role> comingoutMap = new HashMap<>();
	/** GameInfo.talkList読み込みのヘッド */
	protected int talkListHead;
	/** 人間リスト */
	protected Set<Agent> humans = new HashSet<>();
	/** 人狼リスト */
	protected Set<Agent> werewolves = new HashSet<>();
	/** 予言者COした人数 */
	protected Set<Agent> seerCOList = new HashSet<>();
	/** 狂人COした人数 */
	protected Set<Agent> possesseCOList = new HashSet<>();
	protected Set<Agent> mediumCOlist = new HashSet<>();
	/** 乱数変数（Boolean) */
	protected int rdm;
	Random rnd = new Random();
	protected Map<Agent, Agent> voteTarget = new HashMap<>();
	protected Map<Agent, Integer> voteCountTarget = new HashMap<>();
	protected int turn;
	/** 狂人リスト */
	protected Set<Agent> fakeSeer = new HashSet<>();
	protected List<Agent> dangerAgent = new ArrayList<>();
	/** 嘆き */
	protected List<Talk> whisperList = new ArrayList<>();
	/** 投票 */
	protected List<Vote> voteList = new ArrayList<>();
	protected Map<Agent, Boolean> voteWhite = new HashMap<>();
	protected Map<Agent, Boolean> voteBlack = new HashMap<>();
	protected boolean turn0;
	protected Map<Agent, Agent> suspicionTarget = new HashMap<>();
	protected List<Entry<Agent, Integer>> list_entries = new ArrayList<Entry<Agent, Integer>>();
	protected int maxNumWerewolves;
	protected winRate winRate;
	protected List<Agent> myBlackDivinedList = new ArrayList<>();
	protected Agent successGurdeAgent;

	public Tomato15BasePlayer(winRate winRate) {
		// TODO 自動生成されたコンストラクター・スタブ
		this.winRate = winRate;
	}

	/** エージェントが生きているかどうかを返す */
	protected boolean isAlive(Agent agent) {
		return currentGameInfo.getStatusMap().get(agent) == Status.ALIVE;
	}

	/** エージェントが殺されたかどうかを返す */
	protected boolean isKilled(Agent agent) {
		return killedAgents.contains(agent);
	}

	/** エージェントがカミングアウトしたかどうかを返す */
	protected boolean isCo(Agent agent) {
		return comingoutMap.containsKey(agent);
	}

	/** 役職がカミングアウトされたかどうかを返す */
	protected boolean isCo(Role role) {
		return comingoutMap.containsValue(role);
	}

	/** エージェントが人間かどうかを返す */
	protected boolean isHuman(Agent agent) {
		return humans.contains(agent);
	}

	/** エージェントが人狼かどうかを返す */
	protected boolean isWerewolf(Agent agent) {
		return werewolves.contains(agent);
	}

	/** リストからランダムに選んで返す */
	protected <T> T randomSelect(List<T> list) {
		if (list.isEmpty()) {
			return null;
		} else {
			return list.get((int) (Math.random() * list.size()));
		}
	}

	public String getName() {
		return "Tomato5BasePlayer";
	}

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		day = -1;
		me = gameInfo.getAgent();
		myRole = gameInfo.getRole();
		aliveOthers = new ArrayList<>(gameInfo.getAliveAgentList());
		aliveOthers.remove(me);
		executedAgents.clear();
		killedAgents.clear();
		divinationList.clear();
		identList.clear();
		comingoutMap.clear();
		humans.clear();
		werewolves.clear();
		seerCOList.clear();
		possesseCOList.clear();
		mediumCOlist.clear();
		this.gameSetting = gameSetting;
		turn = 0;
		fakeSeer.clear();
		whisperList.clear();
		voteWhite.clear();
		voteBlack.clear();
		currentGameInfo = gameInfo;
		myBlackDivinedList.clear();
		for (Agent agent : currentGameInfo.getAgentList()) {
			voteWhite.put(agent, false);
			voteBlack.put(agent, false);
		}
		maxNumWerewolves = gameSetting.getRoleNum(Role.WEREWOLF);
		successGurdeAgent = null;
	}

	public void update(GameInfo gameInfo) {
		currentGameInfo = gameInfo;

		// 初日は何もしない
		if (currentGameInfo.getDay() == 0) {
			return;
		}

		//talkListHead = currentGameInfo.getTalkList().size();

		// 2回目の呼び出し以降

		// （夜限定）追放されたエージェントを登録
		addExecutedAgent(currentGameInfo.getLatestExecutedAgent());

		//		System.err.println(talkListHead);
		//		System.err.println(currentGameInfo.getTalkList().size());

		// GameInfo.talkListからカミングアウト・占い報告・霊媒報告を抽出
		for (int i = talkListHead; i < currentGameInfo.getTalkList().size(); i++) {
			Talk talk = currentGameInfo.getTalkList().get(i);
			Agent talker = talk.getAgent();
			if (talker == me) {
				continue;
			}
			Content content = new Content(talk.getText());

//			// subjectがUNSPECの場合は発話者に入れ替える
//			if (content.getSubject() == Content.UNSPEC) {
//				content = replaceSubject(content, talker);
//			}

			parseSentence(content, talker);
		}
		talkListHead = currentGameInfo.getTalkList().size();
		Talk lastTalk = currentGameInfo.getTalkList().get(talkListHead - 1);
		turn = lastTalk.getTurn();

		//占い処理
		//		blackDivineList.clear();
		//		whiteDivineList.clear();
		//		for (Judge j : divinationList) {
		//			if (fakeSeer.contains(j.getAgent()))
		//				continue;
		//			if (!isAlive(j.getTarget()))
		//				continue;
		//			//黒出し処理
		//			if (j.getResult() == Species.WEREWOLF) {
		//				blackDivineList.add(j.getAgent());
		//			}
		//			//白だし処理
		//			if (j.getResult() == Species.HUMAN) {
		//				whiteDivineList.add(j.getAgent());
		//			}
		//		}

		//狂人判定
		for (Judge j : divinationList) {
			//黒出ししたエージェントがお亡くなり
			if (j.getResult() == Species.WEREWOLF && isKilled(j.getTarget())) {
				fakeSeer.add(j.getAgent());
			}
			//人狼の時，狼に白だしor狼以外に黒出し
			if (myRole == Role.WEREWOLF) {
				if (j.getResult() == Species.HUMAN && werewolves.contains(j.getTarget())
						|| j.getResult() == Species.WEREWOLF && humans.contains(j.getTarget())) {
					fakeSeer.add(j.getAgent());
				}
			}
			//人狼以外の時，自分に黒出し
			if (myRole != Role.WEREWOLF) {
				if (j.getResult() == Species.WEREWOLF && j.getTarget() == me) {
					fakeSeer.add(j.getAgent());
				}
			}
		}

		// 囁きの処理
		whisperList = currentGameInfo.getWhisperList();

		// 投票の処理
		voteList = currentGameInfo.getVoteList();
		for (Vote vote : voteList) {
			if (whiteDivineList.contains(vote.getTarget())) {
				voteWhite.put(vote.getAgent(), true);
			}
			if (blackDivineList.contains(vote.getTarget())) {
				voteBlack.put(vote.getAgent(), true);
			}
		}

	}

	// 再帰的に文を解析する
	void parseSentence(Content content, Agent talker) {
		switch (content.getTopic()) {
		case COMINGOUT:
			if (content.getRole() == Role.SEER) {
				seerCOList.add(content.getTarget());
			}
			if (content.getRole() == Role.POSSESSED) {
				possesseCOList.add(content.getTarget());
			}
			if (content.getRole() == Role.MEDIUM) {
				mediumCOlist.add(content.getTarget());
			}
			if (content.getRole() == Role.WEREWOLF) {
				werewolves.add(content.getTarget());
			}
			comingoutMap.put(content.getTarget(), content.getRole());
			break;
		case DIVINED:
			if (comingoutMap.get(content.getTarget()) != Role.SEER)
				break;
			divinationList.add(new Judge(day, content.getTarget(), content.getTarget(), content.getResult()));
			if (content.getResult() == Species.WEREWOLF) {
				blackDivineList.add(content.getTarget());
			}
			if (content.getResult() == Species.HUMAN) {
				whiteDivineList.add(content.getTarget());
			}
			break;
		case IDENTIFIED:
			if (comingoutMap.get(content.getTarget()) != Role.MEDIUM)
				break;
			identList.add(new Judge(day, content.getTarget(), content.getTarget(), content.getResult()));
			break;
		case VOTE:
			voteTarget.put(content.getTarget(), content.getTarget());
			suspicionTarget.put(content.getTarget(), content.getTarget());
			//ターゲット投票回数計測
			int count = 0;
			if (voteCountTarget.containsKey(content.getTarget())) {
				count = voteCountTarget.get(content.getTarget());
			}
			count++;
			voteCountTarget.put(content.getTarget(), count);
			// 降順ソート
			List<Entry<Agent, Integer>> list_entries_tmp = new ArrayList<Entry<Agent, Integer>>(
					voteCountTarget.entrySet());
			list_entries.clear();
			for (Entry<Agent, Integer> entry : list_entries_tmp) {
				list_entries.add(entry);
			}

			//			list_entries = list_entries_tmp;
			Collections.sort(list_entries, new Comparator<Entry<Agent, Integer>>() {
				//compareを使用して値を比較する
				public int compare(Entry<Agent, Integer> obj1, Entry<Agent, Integer> obj2) {
					//降順
					return obj2.getValue().compareTo(obj1.getValue());
				}
			});
			break;
		case ESTIMATE:
			if (content.getRole() == Role.WEREWOLF)
				suspicionTarget.put(content.getTarget(), content.getTarget());
			break;
		case OPERATOR:
			parseOperator(content, talker);
			if (content.getOperator() == Operator.REQUEST) {

			}
		default:
			break;
		}
	}

	// 演算子文を解析する
	void parseOperator(Content content, Agent talker) {
		switch (content.getOperator()) {
		case BECAUSE:
			parseSentence(content.getContentList().get(1), talker);
			break;
		case DAY:
			parseSentence(content.getContentList().get(0), talker);
			break;
		case AND:
		case OR:
		case XOR:
			for (Content c : content.getContentList()) {
				parseSentence(c, talker);
			}
			break;
		case REQUEST:
			for (Content c : content.getContentList()) {
				if (c.getTopic() == Topic.VOTE) {
					suspicionTarget.put(content.getTarget(), content.getTarget());
				}
			}
			break;
		case INQUIRE:
			break;
		default:
			break;
		}
	}

	public void dayStart() {
		maxNumWerewolves = Math.min(3, (aliveOthers.size() + 1) / 2);
		canTalk = true;
		canWhisper = false;
		if (currentGameInfo.getRole() == Role.WEREWOLF) {
			canWhisper = true;
		}
		day = currentGameInfo.getDay();
		talkQueue.clear();
		whisperQueue.clear();
		declaredVoteCandidate = null;
		voteCandidate = null;
		declaredAttackVoteCandidate = null;
		attackVoteCandidate = null;
		talkListHead = 0;
		voteList.clear();
		whisperList.clear();
		suspicionTarget.clear();
		voteCountTarget.clear();
		// 前日に追放されたエージェントを登録
		addExecutedAgent(currentGameInfo.getExecutedAgent());
		// 昨夜死亡した（襲撃された）エージェントを登録
		if (!currentGameInfo.getLastDeadAgentList().isEmpty()) {
			addKilledAgent(currentGameInfo.getLastDeadAgentList().get(0));
		}
		Collections.shuffle(aliveOthers);
		voteTarget.clear();
		list_entries.clear();
		turn0 = true;
		//乱数決定;
		rdm = rnd.nextInt(100);
		for(Agent a: myBlackDivinedList) {
			if(currentGameInfo.getExecutedAgent() == a || currentGameInfo.getLastDeadAgentList().get(0) == a) {
				myBlackDivinedList.remove(a);
			}
		}
	}

	private void addExecutedAgent(Agent executedAgent) {
		if (executedAgent != null) {
			aliveOthers.remove(executedAgent);
			if (!executedAgents.contains(executedAgent)) {
				executedAgents.add(executedAgent);
			}
		}
	}

	private void addKilledAgent(Agent killedAgent) {
		if (killedAgent != null) {
			aliveOthers.remove(killedAgent);
			if (!killedAgents.contains(killedAgent)) {
				killedAgents.add(killedAgent);
			}
		}
	}

	/** 投票先候補を選びvoteCandidateにセットする */
	protected void chooseVoteCandidate() {
	}

	public String talk() {
		if (currentGameInfo.getDay() < 1) {
			return "Over";
		}
		String returnstr = talkQueue.isEmpty() ? Talk.SKIP : talkQueue.poll().getText();
		return returnstr;
	}

	/** 襲撃先候補を選びattackVoteCandidateにセットする */
	protected void chooseAttackVoteCandidate() {
	}

	public String whisper() {
		return whisperQueue.isEmpty() ? Talk.SKIP : whisperQueue.poll().getText();
	}

	public Agent vote() {
		canTalk = false;
		return voteCandidate != null ? voteCandidate : randomSelect(aliveOthers);
	}

	public Agent attack() {
		canWhisper = false;
		canWhisper = true;
		return attackVoteCandidate;
	}

	public Agent divine() {
		return null;
	}

	public Agent guard() {
		return null;
	}

	public void finish() {
	}

}
