package jp.ac.aitech.k16106kk.Player5;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ac.aitech.k16106kk.metaStrategy.winRate;

public class Tomato5Villager extends Tomato5BasePlayer {

	public Tomato5Villager(winRate winRate) {
		// TODO 自動生成されたコンストラクター・スタブ
		super(winRate);
	}

	Agent lieBlackResultAgent;
	Agent wolfCoAgent;
	boolean myBlackDivaindFlag;
	int blackDivineCount;
	int firstCoCount;

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		lieBlackResultAgent = null;
		wolfCoAgent = null;
		myBlackDivaindFlag = false;
		blackDivineCount = 0;
		firstCoCount = 0;
	}

	// 1日目
	protected void firstDayTalk() {

		List<Agent> candidates = new ArrayList<>(aliveOthers);

		//白だしされたエジェーントの除外
		for (Agent agent : aliveOthers) {
			if (whiteDivineList.contains(agent)) {
				candidates.remove(agent);
			}
		}

		//初日占いCO＝２
		if (numFirstCo <= 2) {
			for (Agent agent: seerCOList)
				candidates.remove(agent);
			lieBlackResultAgent = randomSelect(winRate.chooseAgentsGetMostWinner(candidates));
			if(lieBlackResultAgent == null) lieBlackResultAgent = randomSelect(candidates);
		} else {
			//初日占いCO＞＝３
			lieBlackResultAgent = randomSelect(winRate.chooseAgentsGetMostWinner(seerCOList));
			if(lieBlackResultAgent == null) lieBlackResultAgent = randomSelect(seerCOList);
		}

		// 黒を出されたエージェントを優先的に吊る
		List<Agent> blackCandidates = new ArrayList<>();
		for (Agent agent : candidates) {
			if (blackDivineList.contains(agent)) {
				blackCandidates.add(agent);
			}
		}
		// 候補が残らなかったら全員から
		if (candidates.isEmpty()) {
			candidates = new ArrayList<>(aliveOthers);
		}

		//投票先の決定
		if (!blackCandidates.isEmpty()) {
			lieBlackResultAgent = randomSelect(blackCandidates);
			voteCandidate = lieBlackResultAgent;
		} else {
			voteCandidate = lieBlackResultAgent;
		}
		if (voteCandidate == null) {
			voteCandidate = randomSelect(winRate.getMostWinner());
			if(voteCandidate == null) voteCandidate = randomSelect(candidates);
		}

		// 投票先を宣言
		if (voteCandidate != null && voteCandidate != declaredVoteCandidate) {
			talkQueue.clear();
			talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
//			talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
//			talkQueue.offer(new Content(
//					new RequestContentBuilder(
//							null, new Content(
//									new VoteContentBuilder(voteCandidate)))));
			declaredVoteCandidate = voteCandidate;
		}
	}

	protected void secondDayTalk() {
		Role fakeRole = null;
		List<Agent> candidates = new ArrayList<>();

		if (numFirstCo == 1) {
			//真占いのみ
			for (Agent agent : aliveOthers) {
				if (firstDayCo.contains(agent))
					continue;
				candidates.add(agent);
			}
		} else if (numFirstCo == 2) {
			//非CO釣り
			for (Agent agent : aliveOthers) {
				if (firstDayCo.contains(agent))
					continue;
				candidates.add(agent);
			}
			//人狼パワープレイの阻止
			if (numAliveCo > 0) {
				fakeRole = Role.WEREWOLF;
			}
		} else if (numFirstCo == 3) {
			if (numAliveCo == 1) {
				//村村狼のためCO釣り
				for (Agent agent : aliveOthers) {
					if (!firstDayCo.contains(agent))
						continue;
					candidates.add(agent);
				}
			} else if (numAliveCo == 2) {
				//村狂狼or村狼占
				//パワープレイ阻止
				fakeRole = Role.WEREWOLF;
			}
		}
		// 候補が残らなかったら全員から
		if (candidates.isEmpty())
			candidates = new ArrayList<>(aliveOthers);
		//投票先選択
		if (voteCandidate == null)
			voteCandidate = randomSelect(candidates);
			wolfCoAgent = voteCandidate;
		//発言
		talkQueue.clear();
		if (fakeRole != null) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, fakeRole)));
			talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
			talkQueue.offer(new Content(
					new RequestContentBuilder(
							null, new Content(
									new VoteContentBuilder(voteCandidate)))));
		}

	}

	protected void chooseVoteCandidate() {

		if(werewolfCO5List.size() == 1 && turn <= 1) {
			voteCandidate = werewolfCO5List.get(0);
			wolfCoAgent = voteCandidate;
		} else if (werewolfCO5List.size() >= 2) {
			voteCandidate = wolfCoAgent;
		}
	}

	public void dayStart() {
		super.dayStart();
		if (day == 2)
			secondDayTalk();
	}

	public String talk() {

		if(day == 1) {
			if (turn >= 1) {
				firstDayTalk();
			}
		}

		if (day == 2)
			chooseVoteCandidate();

		return super.talk();
	}

	public String whisper() {
		throw new UnsupportedOperationException();
	}

	public Agent attack() {
		throw new UnsupportedOperationException();
	}

	public Agent divine() {
		throw new UnsupportedOperationException();
	}

	public Agent guard() {
		throw new UnsupportedOperationException();
	}

}
