package jp.ac.aitech.k16106kk.Player5;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinedResultContentBuilder;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ac.aitech.k16106kk.metaStrategy.winRate;

public class Tomato5Werewolf extends Tomato5BasePlayer {

	public Tomato5Werewolf(winRate winRate) {
		// TODO 自動生成されたコンストラクター・スタブ
		super(winRate);
	}
	boolean seerPlay;
	boolean isDivind;
	List<Agent> possessedCandidate = new ArrayList<>();
	int seerCoCount;

	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		seerPlay = rdm;
		possessedCandidate.clear();
		isDivind = false;
		seerCoCount = 0;
		// 騙る役職を決定する
		if (Math.random() < 0.2) {
			seerPlay = true;
		} else {
			seerPlay = false;
		}
	}

	public void dayStart() {
		super.dayStart();

		//初日確率で占い偽り==狂人
		if (day == 1 && seerPlay) {
			voteCandidate = randomSelect(winRate.getMostWinner());
			if(voteCandidate==null) voteCandidate = randomSelect(aliveOthers);
			talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.SEER)));
			comingoutMap.put(me, Role.SEER);
		}

		if (day == 2) {
			if (seerPlay) {
				//狂人プレイ
				if (numAliveCo == 2) {
					//狼狂村，狼占村，パワープレイ強行
					for (Agent agent : aliveOthers) {
						if (!firstDayCo.contains(agent))
							voteCandidate = agent;
					}

					talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
					talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					talkQueue.offer(new Content(
							new RequestContentBuilder(
									null, new Content(
											new VoteContentBuilder(voteCandidate)))));

				} else if (numAliveCo == 3) {
					//狼狂占．パワープレイ
					voteCandidate = randomSelect(aliveOthers);

					talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
					talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					talkQueue.offer(new Content(
							new RequestContentBuilder(
									null, new Content(
											new VoteContentBuilder(voteCandidate)))));
				}
			} else {
				//村人潜伏
				if (numAliveCo == 1) {
					//狼狂村，狼占村 パワープレイ
					voteCandidate = randomSelect(aliveOthers);

					talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
					talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					talkQueue.offer(new Content(
							new RequestContentBuilder(
									null, new Content(
											new VoteContentBuilder(voteCandidate)))));
				} else if (numAliveCo == 2) {
					//狼狂占
					voteCandidate = randomSelect(aliveOthers);

					talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
					talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					talkQueue.offer(new Content(
							new RequestContentBuilder(
									null, new Content(
											new VoteContentBuilder(voteCandidate)))));
				} else {
					//他候補
					voteCandidate = randomSelect(aliveOthers);
					talkQueue.offer(new Content(new ComingoutContentBuilder(me, Role.WEREWOLF)));
					talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					talkQueue.offer(new Content(
							new RequestContentBuilder(
									null, new Content(
											new VoteContentBuilder(voteCandidate)))));
				}
			}
		}
	}

	public void update(GameInfo gameInfo) {
		super.update(gameInfo);
		possessedCandidate.clear();
		for (Judge j : divinationList) {
			if (possessedCandidate.contains(j.getAgent()))
				;
			//自分以外に黒出し
			if (j.getTarget() != me && j.getResult() == Species.WEREWOLF) {
				possessedCandidate.add(j.getAgent());
			}
			//自分に白だし
			if (j.getTarget() == me && j.getResult() == Species.HUMAN) {
				possessedCandidate.add(j.getAgent());
			}
		}
	}

	//１日目村人偽り
	protected void firstDayTalk() {
		List<Agent> candidates = new ArrayList<>(aliveOthers);
		Agent mostVoteAgent = null;
		Agent nextMostVoteAgent = null;

		// 非CO吊り
		if(seerCoCount != numFirstCo) {
			for (Agent agent : aliveOthers) {
				if (comingoutMap.get(agent) == Role.SEER)
					candidates.remove(agent);
			}
			if (candidates.isEmpty())
				candidates = new ArrayList<>(aliveOthers);
		}

		// 投票先を設定
		voteCandidate = randomSelect(winRate.chooseAgentsGetMostWinner(candidates));
		if(voteCandidate == null) voteCandidate = randomSelect(candidates);
		// 自分が釣られそうな場合，票合わせをおこない無効票にする
		// もっとも投票されているエージェントを取得
		if (!list_entries.isEmpty()) {
			mostVoteAgent = list_entries.get(0).getKey();
		}
		if (mostVoteAgent == me) {
			// 次に投票されているエージェントを取得
			if (!list_entries.isEmpty()) {
				nextMostVoteAgent = list_entries.get(1).getKey();
			}
			voteCandidate = nextMostVoteAgent;
		}


		// 投票先を宣言
		if (voteCandidate != null && voteCandidate != declaredVoteCandidate) {
			talkQueue.clear();
			talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
//			talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
//			talkQueue.offer(new Content(
//					new RequestContentBuilder(
//							null, new Content(
//									new VoteContentBuilder(voteCandidate)))));
			declaredVoteCandidate = voteCandidate;
		}
	}

	public String talk() {
		// 1日目は村人または占いとほぼ同じように動く
		if (day == 1 && !seerPlay) {
			// 潜伏
			if (turn >= 1) {
				firstDayTalk();
				seerCoCount = numFirstCo;
			}
		} else if (day == 1 && seerPlay) {
			if (!isDivind) {
				talkQueue.offer(new Content(
						new DivinedResultContentBuilder(voteCandidate, Species.WEREWOLF)));
				talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
//				talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate, Role.WEREWOLF)));
//				talkQueue.offer(new Content(
//						new RequestContentBuilder(
//								null, new Content(
//										new VoteContentBuilder(voteCandidate)))));
				isDivind = true;
			}
			if(turn <= 2) {
				for(Agent agent : seerCOList) {
					if(voteCandidate == agent) {
						talkQueue.clear();
						isDivind = false;
						List<Agent> candidates = new ArrayList<>(aliveOthers);
						// 非CO吊り
						for (Agent a : aliveOthers) {
							if (comingoutMap.get(a) == Role.SEER)
								candidates.remove(a);
						}
						voteCandidate = randomSelect(winRate.chooseAgentsGetMostWinner(candidates));
						if(voteCandidate == null) voteCandidate = randomSelect(candidates);
					}
				}
			}
		}

		if (day == 2) {
			// 狂CO待ち
			for (Agent agent : aliveOthers) {
				if (comingoutMap.get(agent) == Role.POSSESSED
						&& firstDayCo.contains(agent)
						&& !possessedCandidate.contains(agent))
					possessedCandidate.add(agent);
			}
			// 狂人が特定できているとき
			if (possessedCandidate.size() == 1) {
				for (Agent agent : aliveOthers) {
					if (!possessedCandidate.contains(agent)) {
						voteCandidate = agent;
						talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					}
				}
			}
			// 便乗票
			if (!voteTarget.containsValue(voteCandidate)) {
				for (Agent agent : aliveOthers) {
					if (voteTarget.containsValue(agent)) {
						voteCandidate = agent;
//						talkQueue.offer(new Content(new VoteContentBuilder(voteCandidate)));
					}
				}
			}
		}
		return super.talk();
	}

	protected void chooseAttackVoteCandidate() {
		List<Agent> candidates = new ArrayList<>();

		if (seerPlay) {
			// 自分が騙っているのでCO内訳は真狂狼
			// 狂噛みを避けるために村人を噛む
			// COが1人吊られている場合、真が残れば詰むけどそれは諦める
			for (Agent agent : aliveOthers) {
				if (possessedCandidate.contains(agent))
					continue;
				if (!firstDayCo.contains(agent))
					candidates.add(agent);
			}
		} else {
			// 潜伏　CO内訳は真狂
			if (numAliveCo == 1) {
				// 真占が残って詰むのを防ぐためにCO噛み
				for (Agent agent : aliveOthers) {
					if (possessedCandidate.contains(agent))
						continue;
					if (firstDayCo.contains(agent))
						candidates.add(agent);
				}
			} else if (numAliveCo == 2) {
				// 狂噛みを避けるために村人を噛む
				for (Agent agent : aliveOthers) {
					if (possessedCandidate.contains(agent))
						continue;
					if (!firstDayCo.contains(agent))
						candidates.add(agent);
				}
			}
		}
		if (candidates.isEmpty()) {
			for (Agent agent : aliveOthers) {
				if (possessedCandidate.contains(agent))
					continue;
				candidates.add(agent);
			}
		}
		attackVoteCandidate = randomSelect(winRate.chooseAgentsGetMostWinner(candidates));
		if(attackVoteCandidate == null) attackVoteCandidate = randomSelect(candidates);
		if (attackVoteCandidate == null) attackVoteCandidate = randomSelect(aliveOthers);
	}

}
